(function ( $ ) {
    $( document ).ready( function () {
        progressUpdate();
        setInterval( progressUpdate, 5000 );

        $( '#upd-amazon-plugin-form' ).submit( function ( e ) {
            e.preventDefault();
        } );

        $( '#expand-btn' ).click( function ( e ) {
            e.preventDefault();

            $( '#response-msg-row' ).hide();

            let data = {
                action: 'upd_amazon_expand',
                security: upd_amazon_admin.nonce,
            };

            processRequest( data );
        } );

        $( '#update-btn' ).click( function ( e ) {
            e.preventDefault();

            $( '#response-msg-row' ).hide();

            let data = {
                action: 'upd_amazon_update',
                new_id: $( '#new-id' ).val(),
                security: upd_amazon_admin.nonce,
            };

            processRequest( data );
        } );

        $( '#no_follow-btn' ).click( function ( e ) {
            e.preventDefault();

            $( '#response-msg-row' ).hide();

            let data = {
                action: 'upd_amazon_no_follow',
                security: upd_amazon_admin.nonce,
            };

            processRequest( data );
        } );

        $( '#no_affiliate-btn' ).click( function ( e ) {
            e.preventDefault();

            $( '#response-msg-row' ).hide();

            let data = {
                action: 'upd_amazon_no_affiliate',
                security: upd_amazon_admin.nonce,
            };

            processRequest( data );
        } );
    } );

    function processRequest( data ) {
        let responseMsgRow = $( '#response-msg-row' );
        let responseMsg    = $( '#response-msg' );

        $.post( ajaxurl, data, function () {
        } ).done( response => {
            responseMsg.text( response.data.message );
            responseMsg.css( {
                'color': '#087f23'
            } );
            $( '#upd-amazon-plugin-form .button' ).prop( 'disabled', true );
        } ).fail( function ( response ) {
            responseMsg.text( response.responseJSON.data.message );
            responseMsg.css( {
                'color': '#aa000a'
            } );
        } ).always( function () {
            responseMsgRow.show();
        } );
    }

    function progressUpdate() {
        let responseMsgRow = $( '#response-msg-row' );
        let responseMsg    = $( '#response-msg' );
        let progressRow    = $( '#progress-row' );

        let data = {
            action: 'upd_amazon_get_progress',
            security: upd_amazon_admin.nonce,
        };

        $.post( ajaxurl, data, function () {
        } ).done( response => {
            let job = response.data;

            if (job) {
                if (job.percent === '100') {
                    progressRow.hide();
                    responseMsg.text( `Plugin updated ${job.processed} posts/pages.` );
                    responseMsg.css( {
                        'color': '#087f23'
                    } );
                    responseMsgRow.show();
                    $( '#upd-amazon-plugin-form .button' ).prop( 'disabled', false );
                } else {
                    responseMsgRow.hide();
                    progressRow.show();
                    $( '#upd-amazon-plugin-form .button' ).prop( 'disabled', true );
                    $( '#progress-row .progress-bar' ).width( job.percent + '%' );
                    $( '#progress-result' ).html( 'Progress: ' + job.percent + '% <br>Started at: ' + job.started_at );
                }
            }
        } );
    }
})( jQuery );
