<?php

namespace Lightweb_Media\UPD_Amazon\Abstracts;

defined( 'ABSPATH' ) || exit;

use Lightweb_Media\UPD_Amazon\Abstracts\Interfaces\UPD_Amazon_Singleton_Interface;

/**
 * Class UPD_Amazon_Singleton_Abstract
 *
 * @package Lightweb_Media\UPD_Amazon\Abstracts
 */
abstract class UPD_Amazon_Singleton_Abstract implements UPD_Amazon_Singleton_Interface {

	/**
	 * @var array
	 */
	protected static array $instances = array();

	/**
	 * @return $this
	 */
	public static function get_instance(): self {
		$class = static::class;

		if ( ! array_key_exists( $class, self::$instances ) ) {
			self::$instances[ $class ] = new $class();
		}

		return self::$instances[ $class ];
	}

	/**
	 * Cloning is forbidden
	 */
	public function __clone() {
		_doing_it_wrong( __FUNCTION__, 'Cheatin&#8217; huh?', '1.0.0' );
	}

	/**
	 * Unserializing instances of this class is forbidden
	 */
	public function __wakeup() {
		_doing_it_wrong( __FUNCTION__, 'Cheatin&#8217; huh?', '1.0.0' );
	}
}
