<?php

namespace Lightweb_Media\UPD_Amazon\Abstracts\Interfaces;

defined( 'ABSPATH' ) || exit;

/**
 * Interface UPD_Amazon_Singleton_Interface
 *
 * @package Lightweb_Media\UPD_Amazon\Abstracts\Interfaces
 */
interface UPD_Amazon_Singleton_Interface {

	/**
	 * @return $this
	 */
	public static function get_instance(): self;

	/**
	 * Cloning is forbidden
	 */
	public function __clone();

	/**
	 * Unserializing instances of this class is forbidden
	 */
	public function __wakeup();
}
