<?php

namespace Lightweb_Media\UPD_Amazon\Admin;

defined( 'ABSPATH' ) || exit;

use Lightweb_Media\UPD_Amazon\Abstracts\UPD_Amazon_Singleton_Abstract;
use Lightweb_Media\UPD_Amazon\Admin\Interfaces\UPD_Amazon_Admin_Menus_Interface;

/**
 * Class UPD_Amazon_Admin_Menus
 *
 * @package Lightweb_Media\UPD_Amazon\Admin
 */
class UPD_Amazon_Admin_Menus extends UPD_Amazon_Singleton_Abstract implements UPD_Amazon_Admin_Menus_Interface {

	/**
	 * UPD_Amazon_Admin_Menus constructor
	 */
	public function __construct() {
		if ( is_admin() ) {
			$this->init_hooks();
		}
	}

	/**
	 * Init / set up hooks
	 */
	private function init_hooks(): void {
		add_action( 'admin_menu', array( $this, 'admin_menu_action' ) );
	}

	/**
	 * Introduce admin menu
	 */
	public function admin_menu_action(): void {
		add_menu_page(
			'Search & Replace Amazon Affiliate Links', 'Search & Replace Amazon Affiliate Links',
			'manage_options', 'uralp-upd-amazon-plugin', array( $this, 'upd_amazon_page' ), 'dashicons-update-alt'
		);
	}

	/**
	 * Output the plugin page
	 */
	public function upd_amazon_page(): void {
		UPD_Amazon_Admin_Templates::get_instance()->get_admin_template( 'upd-amazon' );
	}
}
