<?php

namespace Lightweb_Media\UPD_Amazon\Admin;

defined( 'ABSPATH' ) || exit;

use Lightweb_Media\UPD_Amazon\Abstracts\UPD_Amazon_Singleton_Abstract;
use Lightweb_Media\UPD_Amazon\Admin\Interfaces\UPD_Amazon_Admin_Interface;

/**
 * Class UPD_Amazon_Admin
 *
 * @package Lightweb_Media\UPD_Amazon\Admin
 */
class UPD_Amazon_Admin extends UPD_Amazon_Singleton_Abstract implements UPD_Amazon_Admin_Interface {

	/**
	 * UPD_Amazon_Admin constructor
	 */
	public function __construct() {
		if ( is_admin() ) {
			$this->init_admin_classes();
		}
	}

	/**
	 * Init important admin classes
	 */
	private function init_admin_classes(): void {
		UPD_Amazon_Admin_Menus::get_instance();
		UPD_Amazon_Admin_Assets::get_instance();
		UPD_Amazon_Admin_AJAX::get_instance();
	}
}
