<?php

namespace Lightweb_Media\UPD_Amazon\Admin\Interfaces;

defined( 'ABSPATH' ) || exit;

/**
 * Interface UPD_Amazon_Admin_AJAX_Interface
 *
 * @package Lightweb_Media\UPD_Amazon\Admin\Interfaces
 */
interface UPD_Amazon_Admin_AJAX_Interface {

	/**
	 * UPD_Amazon_Admin_AJAX constructor
	 */
	public function __construct();

	/**
	 * Schedules the expanding of shortened Amazon links
	 *
	 * @return void
	 */
	public function wp_ajax_upd_amazon_expand_action(): void;

	/**
	 * Schedules the update from short to long links including the affiliate tag
	 *
	 * @return void
	 */
	public function wp_ajax_upd_amazon_update_action(): void;

	/**
	 * Schedules the adding of the no follow attribute to the links
	 *
	 * @return void
	 */
	public function wp_ajax_upd_amazon_no_follow_action(): void;

	/**
	 * Schedules the removing of the Amazon affiliate links
	 *
	 * @return void
	 */
	public function wp_ajax_upd_amazon_no_affiliate_action(): void;

	/**
	 * Returns the current progress of a job/action
	 *
	 * @return void
	 */
	public function wp_ajax_upd_amazon_get_progress_action(): void;
}
