<?php

namespace Lightweb_Media\UPD_Amazon\Interfaces;

defined( 'ABSPATH' ) || exit;

/**
 * Interface UPD_Amazon_Search_Replacer_Interface
 *
 * @package Lightweb_Media\UPD_Amazon\Interfaces
 */
interface UPD_Amazon_Search_Replacer_Interface {

	/**
	 * UPD_Amazon_Search_Replacer constructor
	 */
	public function __construct();

	/**
	 * Performs the expanding of shortened Amazon links
	 *
	 * @param int $posts_idx
	 *
	 * @return void
	 */
	public function expand( int $posts_idx ): void;

	/**
	 * Performs the update from short to long links including the affiliate tag
	 *
	 * @param string $new_id
	 * @param int $posts_idx
	 *
	 * @return void
	 */
	public function update_db( string $new_id, int $posts_idx ): void;

	/**
	 * Performs the adding of the no follow attribute to the links
	 *
	 * @param int $posts_idx
	 *
	 * @return void
	 */
	public function no_follow( int $posts_idx ): void;

	/**
	 * Performs the removing of the Amazon affiliate links
	 *
	 * @param int $posts_idx
	 *
	 * @return void
	 */
	public function no_affiliate( int $posts_idx ): void;

	/**
	 * Returns the last job
	 *
	 * @param bool $check_finished
	 *
	 * @return array|null
	 */
	public function get_last_job( bool $check_finished = false ): ?array;
}
