<?php
/**
 * Plugin Name: Search & Replace Affiliate Links for Amazon
 * Description: Search & Replace Affiliate Links for Amazon. Plugin that allows you to replace tag parameter on links that go to Amazon.
 * Version: 1.1.1
 * Author: Lightweb Media GmbH - Johannes Gmelin
 * Author URI: https://lightweb-media.de
 * Requires at least: 5.4.0
 * Requires PHP: 7.4.0
 * Tested up to: 6.4.1
 *
 * @package Lightweb_Media\UPD_Amazon
 */

defined( 'ABSPATH' ) || exit;

use Lightweb_Media\UPD_Amazon\UPD_Amazon;
use YahnisElsts\PluginUpdateChecker\v5\PucFactory;

// Needed constants for main class initialization only
if ( ! defined( 'UPD_AMAZON_PLUGIN_FILE' ) ) {
	define( 'UPD_AMAZON_PLUGIN_FILE', __FILE__ );
}

if ( ! defined( 'UPD_AMAZON_ABSPATH' ) ) {
	define( 'UPD_AMAZON_ABSPATH', realpath( plugin_dir_path( UPD_AMAZON_PLUGIN_FILE ) ) . DIRECTORY_SEPARATOR );
}
// End of needed constants for main class initialization

if ( file_exists( UPD_AMAZON_ABSPATH . 'vendor' . DIRECTORY_SEPARATOR . 'autoload.php' ) ) {
	require UPD_AMAZON_ABSPATH . 'vendor' . DIRECTORY_SEPARATOR . 'autoload.php';
}

UPD_Amazon::get_instance();

PucFactory::buildUpdateChecker(
	'http://plugins.lightweb-media.de/api?action=get_metadata&slug=search-and-replace-affiliate-links-for-amazon', //Metadata URL.
	__FILE__, //Full path to the main plugin file.
	'search-and-replace-affiliate-links-for-amazon' //Plugin slug. Usually it's the same as the name of the directory.
);
