<?php

namespace Lightweb_Media\Lightweb_Media_Plugin_Sidebar\Abstracts;

defined( 'ABSPATH' ) || exit;

use Lightweb_Media\Lightweb_Media_Plugin_Sidebar\Abstracts\Interfaces\LWM_Plugin_Sidebar_Singleton_Interface;

/**
 * Class LWM_Plugin_Sidebar_Singleton_Abstract
 *
 * @package Lightweb_Media\Lightweb_Media_Plugin_Sidebar\Abstracts
 */
abstract class LWM_Plugin_Sidebar_Singleton_Abstract implements LWM_Plugin_Sidebar_Singleton_Interface {

	/**
	 * @var array
	 */
	protected static array $instances = array();

	/**
	 * @return $this
	 */
	public static function get_instance(): self {
		$class = static::class;

		if ( ! array_key_exists( $class, self::$instances ) ) {
			self::$instances[ $class ] = new $class();
		}

		return self::$instances[ $class ];
	}

	/**
	 * Cloning is forbidden
	 */
	public function __clone() {
		_doing_it_wrong( __FUNCTION__, esc_html__( 'Cheatin&#8217; huh?', 'lightweb-media-plugin-sidebar' ), '1.0.0' );
	}

	/**
	 * Unserializing instances of this class is forbidden
	 */
	public function __wakeup() {
		_doing_it_wrong( __FUNCTION__, esc_html__( 'Cheatin&#8217; huh?', 'lightweb-media-plugin-sidebar' ), '1.0.0' );
	}
}
